/*********************/
/*---- DITHER.H -----*/
/*********************/
#if !defined(__DITHER)
#define __DITHER

#if !defined(__IMAGE_IO)
#include "..\tools\image_io.h"
#endif

#define DITHER_AUTO     0   /* Meilleur choix suivant rsolution */
#define DITHER_SEUIL    1   /* Mthode Matrice de seuil          */
#define DITHER_GRIS     2   /* Niveaux de gris                   */
#define DITHER_216      3   /* TC --> 216 couleurs               */


/***********************************************/
/* Rduction du nombre de couleurs d'un raster */
/* out->fd_nplanes doit contenir le nombre de  */
/* Plans dsirs pour le rsultat.             */
/* out est cre par cette fonction.            */
/* En retour :                                 */
/*              0 : OK                         */
/*             -1 : Mmoire insuffisante       */
/*             -2 : Donnes incohrentes       */
/***********************************************/
int dither(int method, MFDB *in, INFO_IMAGE *inf, MFDB *out, GEM_WINDOW *wprog) ;

/***********************************************/
/* Rduction du nombre de couleurs d'un raster */
/* out->fd_nplanes doit contenir le nombre de  */
/* Plans dsirs pour le rsultat.             */
/* out est cre par cette fonction.            */
/* De plus, un facteur d'chelle est autoris  */
/* En retour :                                 */
/*              0 : OK                         */
/*             -1 : Mmoire insuffisante       */
/*             -2 : Donnes incohrentes       */
/***********************************************/
int dither_ratio(MFDB *in, INFO_IMAGE *inf, MFDB *out, int pc_x, int pc_y,
                 GEM_WINDOW *wprog) ;

#endif
